Index: palm/trunk/SOURCE/advec_s_ups.f90
===================================================================
--- palm/trunk/SOURCE/advec_s_ups.f90	(revision 1)
+++ palm/trunk/SOURCE/advec_s_ups.f90	(revision 1)
@@ -0,0 +1,199 @@
+ SUBROUTINE advec_s_ups( s, var_char )
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+! $Log: advec_s_ups.f90,v $
+! Revision 1.6  2004/04/30 08:02:43  raasch
+! Enlarged transposition arrays introduced
+!
+! Revision 1.5  2003/03/16 09:23:56  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.4  2001/03/29 17:34:05  raasch
+! v_ad is now allocated locally, several temporary arrays removed from
+! argument lists of spline_* and long_filter_*
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.3  2001/01/22 04:46:10  raasch
+! Module test_variables removed
+!
+! Revision 1.2  2000/01/20 09:28:52  letzel
+! All comments translated into English
+!
+! Revision 1.1  1999/02/05 08:44:47  raasch
+! Initial revision
+!
+!
+! Description:
+! ------------
+! Upstream-Spline advection of scalar quantities (potential temperature,
+! turbulent kinetic energy). The advection process is divided into three 
+! subsequent steps, one for each of the dimensions. The result is stored as a 
+! tendency in array tend. The computation of the cubic splines and the possible
+! execution of the Long-filter require that all grid points of the relevant 
+! dimension are available. For model runs on more than one PE therefore both the
+! advected and the advecting quantities are transposed accordingly.
+!
+! Actual arguments:
+! s        = scalar quantity to be advected (remains unchanged in this UP)
+! var_char = character string specifying the quantity to be advected
+!
+! Internally used arrays:
+! v_ad     = scalar quantity to be advected, initialized = s at the beginning,
+!            also being used as temporary storage after each time step
+! d        = advecting component (u, v, or w)
+!------------------------------------------------------------------------------!
+
+    USE advection
+    USE arrays_3d
+    USE cpulog
+    USE grid_variables
+    USE indices
+    USE interfaces
+    USE control_parameters
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*) ::  var_char
+
+    INTEGER ::  i, j, k
+    REAL    ::  s(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1)
+    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  v_ad
+
+    CALL cpu_log( log_point_s(16), 'advec_s_ups', 'start' )
+
+#if defined( __parallel )
+
+!
+!-- Advection of the scalar in x-direction:
+!-- Store the scalar in temporary array v_ad (component to be advected,
+!-- boundaries are not used because they disturb the transposition)
+    ALLOCATE( v_ad(nzb+1:nzta,nys:nyna,nxl:nxra) )
+    v_ad = 0.0
+    v_ad(nzb+1:nzt,nys:nyn,nxl:nxr) = s(nzb+1:nzt,nys:nyn,nxl:nxr)
+
+!
+!-- Enlarge the size of tend, used as a working array for the transpositions
+    IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
+       DEALLOCATE( tend )
+       ALLOCATE( tend(1:nza,nys:nyna,nxl:nxra) )
+    ENDIF
+
+!
+!-- Transpose the component to be advected: z --> x
+    CALL transpose_zx( v_ad, tend, v_ad, tend, v_ad )
+
+#else
+
+!
+!-- Advection of the scalar in x-direction:
+!-- Store the scalar in temporary array v_ad (component to be advected)
+    ALLOCATE( v_ad(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+    v_ad(:,:,:) = s(:,:,:)
+
+#endif
+
+!
+!-- Advecting component (u) must be averaged out on the scalar's grid
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+              d(k,j,i) = 0.5 * ( u(k,j,i) + u(k,j,i+1) ) - u_gtrans
+          ENDDO
+       ENDDO
+    ENDDO
+
+#if defined( __parallel )
+
+!
+!-- Transpose the advecting componnet: z --> x
+    CALL transpose_zx( d, tend, d, tend, d )
+
+#endif
+
+!
+!-- Upstream-Spline advection of the scalar in x-direction
+    CALL spline_x( v_ad, d, var_char )
+
+!
+!-- Advection of the scalar in y-direction:
+!-- advecting component (v) must be averaged out on the scalar's grid
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+              d(k,j,i) = 0.5 * ( v(k,j,i) + v(k,j+1,i) ) - v_gtrans
+          ENDDO
+       ENDDO
+    ENDDO
+
+#if defined( __parallel )
+    
+!
+!-- Transpose the advecting component: z --> y
+    CALL transpose_zx( d, tend, d, tend, d )
+    CALL transpose_xy( d, tend, d, tend, d )
+
+!
+!-- Transpose the component to be advected: x --> y
+    CALL transpose_xy( v_ad, tend, v_ad, tend, v_ad )
+
+#endif
+
+!
+!-- Upstream-Spline advection of the scalar in y-direction
+    CALL spline_y( v_ad, d, var_char )
+
+!
+!-- Advection of the scalar in z-direction:
+!-- the advecting component (w) must be averaged out on the scalar's grid
+!-- (weighted for non-equidistant grid)
+    d = 0.0
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+             d(k,j,i) =  ( w(k,j,i) * ( zu(k) - zw(k-1) ) + &
+                           w(k-1,j,i) * ( zw(k) - zu(k) ) ) * ddzw(k)
+          ENDDO
+       ENDDO
+    ENDDO
+
+#if defined( __parallel )
+
+!
+!-- Transpose the component to be advected: y --> z (= y --> x + x --> z)
+    CALL transpose_yx( v_ad, tend, v_ad, tend, v_ad )
+    CALL transpose_xz( v_ad, tend, v_ad, tend, v_ad )
+
+!
+!-- Resize tend to its normal size
+    IF ( nxra > nxr  .OR.  nyna > nyn  .OR.  nza > nz )  THEN
+       DEALLOCATE( tend )
+       ALLOCATE( tend(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
+    ENDIF
+
+#endif
+
+!
+!-- Upstream-Spline advection of the scalar in z-direction
+    CALL spline_z( v_ad, d, dzu, spl_tri_zu, var_char )
+
+!
+!-- Compute the tendency term
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          DO  k = nzb+1, nzt
+             tend(k,j,i) = ( v_ad(k,j,i) - s(k,j,i) ) / dt_3d 
+          ENDDO
+       ENDDO
+    ENDDO
+
+    DEALLOCATE( v_ad )
+
+    CALL cpu_log( log_point_s(16), 'advec_s_ups', 'stop' )
+
+ END SUBROUTINE advec_s_ups
Index: palm/trunk/SOURCE/advec_u_pw.f90
===================================================================
--- palm/trunk/SOURCE/advec_u_pw.f90	(revision 4901)
+++ palm/trunk/SOURCE/advec_u_pw.f90	(revision 1)
@@ -1,34 +1,42 @@
-!> @file advec_u_pw.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ MODULE advec_u_pw_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
+! $Log: advec_u_pw.f90,v $
+! Revision 1.15  2006/02/23 09:44:21  raasch
+! nzb_2d replaced by nzb_u_inner
 !
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
+! Revision 1.14  2005/03/26 14:49:31  raasch
+! Extension of horizontal loop upper bounds for non-cyclic boundary conditions
 !
-! 3655 2019-01-07 16:51:22Z knoop
-! variables documented
+! Revision 1.13  2004/01/30 10:11:21  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.12  2003/03/12 16:17:06  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
+!
+! Revision 1.11  2002/06/11 12:25:00  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+!
+! Revision 1.10  2001/03/29 17:34:21  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.9  2001/01/22 04:55:36  raasch
+! Module test_variables removed
+!
+! Revision 1.8  2000/01/20 09:34:26  letzel
+! All comments translated into English
+!
+! Revision 1.7  1998/08/05 06:47:04  raasch
+! Alle Gitterpunkte gleich behandelt (keine zentralen Differenzenquotienten
+! mehr bei Vertikaladvektion bei k=1)
 !
 ! Revision 1.1  1997/08/11 06:09:21  raasch
@@ -38,11 +46,9 @@
 ! Description:
 ! ------------
-!> Advection term for u velocity-component using Piacsek and Williams.
-!> Vertical advection at the first grid point above the surface is done with normal centred
-!> differences, because otherwise no information from the surface would be communicated upwards due
-!> to w=0 at K=nzb.
-!--------------------------------------------------------------------------------------------------!
- MODULE advec_u_pw_mod
-
+! Advection term for u velocity-component using Piacsek and Williams.
+! Vertical advection at the first grid point above the surface is done with
+! normal centred differences, because otherwise no information from the surface
+! would be communicated upwards due to w=0 at K=nzb.
+!------------------------------------------------------------------------------!
 
     PRIVATE
@@ -53,104 +59,74 @@
        MODULE PROCEDURE advec_u_pw_ij
     END INTERFACE advec_u_pw
-
+ 
  CONTAINS
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for all grid points
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_u_pw
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_u_pw
 
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzw, tend, u, v, w
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
+       IMPLICIT NONE
 
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
+       INTEGER ::  i, j, k
+       REAL    ::  gu, gv
+ 
+       gu = 2.0 * u_gtrans
+       gv = 2.0 * v_gtrans
+       DO  i = nxl, nxr+uxrp
+          DO  j = nys, nyn
+             DO  k = nzb_u_inner(j,i)+1, nzt
+                tend(k,j,i) = tend(k,j,i) - 0.25 * (                           &
+                         ( u(k,j,i+1) * ( u(k,j,i+1) + u(k,j,i) - gu )         &
+                         - u(k,j,i-1) * ( u(k,j,i) + u(k,j,i-1) - gu ) ) * ddx &
+                       + ( u(k,j+1,i) * ( v(k,j+1,i) + v(k,j+1,i-1) - gv )     &
+                         - u(k,j-1,i) * ( v(k,j,i) + v(k,j,i-1) - gv ) ) * ddy &
+                       + ( u(k+1,j,i) * ( w(k,j,i) + w(k,j,i-1) )              &
+                         - u(k-1,j,i) * ( w(k-1,j,i) + w(k-1,j,i-1) ) )        &
+                                                                  * ddzw(k)    &
+                                                   )
+             ENDDO
+          ENDDO
+       ENDDO
 
-    USE indices,                                                                                   &
-        ONLY:  nxlu, nxr, nyn, nys, nzb, nzt
-
-    USE kinds
+    END SUBROUTINE advec_u_pw
 
 
-    IMPLICIT NONE
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_u_pw_ij( i, j )
 
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
-    REAL(wp)     ::  gu !< Galilei-transformation velocity along x
-    REAL(wp)     ::  gv !< Galilei-transformation velocity along y
+       IMPLICIT NONE
 
-    gu = 2.0_wp * u_gtrans
-    gv = 2.0_wp * v_gtrans
-    DO  i = nxlu, nxr
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt
-             tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                                               &
-                           ( u(k,j,i+1)   * ( u(k,j,i+1) + u(k,j,i) - gu )                         &
-                           - u(k,j,i-1)   * ( u(k,j,i)   + u(k,j,i-1) - gu ) ) * ddx               &
-                           + ( u(k,j+1,i) * ( v(k,j+1,i) + v(k,j+1,i-1) - gv )                     &
-                           - u(k,j-1,i)   * ( v(k,j,i)   + v(k,j,i-1) - gv ) ) * ddy               &
-                           + ( u(k+1,j,i) * ( w(k,j,i)   + w(k,j,i-1) )                            &
-                           - u(k-1,j,i)   * ( w(k-1,j,i) + w(k-1,j,i-1) ) )    * ddzw(k)           &
-                                                   )
-          ENDDO
+       INTEGER ::  i, j, k
+       REAL    ::  gu, gv
+
+       gu = 2.0 * u_gtrans
+       gv = 2.0 * v_gtrans
+       DO  k = nzb_u_inner(j,i)+1, nzt
+          tend(k,j,i) = tend(k,j,i) - 0.25 * (                                 &
+                         ( u(k,j,i+1) * ( u(k,j,i+1) + u(k,j,i) - gu )         &
+                         - u(k,j,i-1) * ( u(k,j,i) + u(k,j,i-1) - gu ) ) * ddx &
+                       + ( u(k,j+1,i) * ( v(k,j+1,i) + v(k,j+1,i-1) - gv )     &
+                         - u(k,j-1,i) * ( v(k,j,i) + v(k,j,i-1) - gv ) ) * ddy &
+                       + ( u(k+1,j,i) * ( w(k,j,i) + w(k,j,i-1) )              &
+                         - u(k-1,j,i) * ( w(k-1,j,i) + w(k-1,j,i-1) ) )        &
+                                                                  * ddzw(k)    &
+                                             )
        ENDDO
-    ENDDO
 
- END SUBROUTINE advec_u_pw
-
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for grid point i,j
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_u_pw_ij( i, j )
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzw, tend, u, v, w
-
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
-
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
-
-    USE indices,                                                                                   &
-        ONLY:  nzb, nzt
-
-    USE kinds
-
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
-
-    REAL(wp)     ::  gu !< Galilei-transformation velocity along x
-    REAL(wp)     ::  gv !< Galilei-transformation velocity along y
-
-    gu = 2.0_wp * u_gtrans
-    gv = 2.0_wp * v_gtrans
-    DO  k = nzb+1, nzt
-       tend(k,j,i) = tend(k,j,i) - 0.25_wp * (                                                     &
-                     ( u(k,j,i+1)   * ( u(k,j,i+1) + u(k,j,i) - gu )                               &
-                     - u(k,j,i-1)   * ( u(k,j,i)   + u(k,j,i-1) - gu ) ) * ddx                     &
-                     + ( u(k,j+1,i) * ( v(k,j+1,i) + v(k,j+1,i-1) - gv )                           &
-                     - u(k,j-1,i)   * ( v(k,j,i)   + v(k,j,i-1) - gv ) ) * ddy                     &
-                     + ( u(k+1,j,i) * ( w(k,j,i)   + w(k,j,i-1) )                                  &
-                     - u(k-1,j,i)   * ( w(k-1,j,i) + w(k-1,j,i-1) ) )    * ddzw(k)                 &
-                                             )
-    ENDDO
-
- END SUBROUTINE advec_u_pw_ij
+    END SUBROUTINE advec_u_pw_ij
 
  END MODULE advec_u_pw_mod
Index: palm/trunk/SOURCE/advec_u_up.f90
===================================================================
--- palm/trunk/SOURCE/advec_u_up.f90	(revision 4901)
+++ palm/trunk/SOURCE/advec_u_up.f90	(revision 1)
@@ -1,34 +1,47 @@
-!> @file advec_u_up.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
+ MODULE advec_u_up_mod
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
 ! -----------------
 ! 
-! 
+!
 ! Former revisions:
 ! -----------------
-! $Id$
-! file re-formatted to follow the PALM coding standard
+! $Log: advec_u_up.f90,v $
+! Revision 1.12  2006/02/23 09:45:04  raasch
+! nzb_2d replaced by nzb_u_inner
 !
-! 4360 2020-01-07 11:25:50Z suehring
-! Corrected "Former revisions" section
+! Revision 1.11  2005/03/26 14:50:43  raasch
+! Extension of horizontal loop upper bounds for non-cyclic boundary conditions
 !
-! 3655 2019-01-07 16:51:22Z knoop
-! variables documented
+! Revision 1.10  2004/01/30 10:11:47  raasch
+! Scalar lower k index nzb replaced by 2d-array nzb_2d
+!
+! Revision 1.9  2003/03/12 16:17:42  raasch
+! Full code replaced in the call for all gridpoints instead of calling the
+! _ij version (required by NEC, because otherwise no vectorization)
+!
+! Revision 1.8  2002/06/11 12:25:43  raasch
+! Former subroutine changed to a module which allows to be called for all grid
+! points of a single vertical column with index i,j or for all grid points by
+! using function overloading.
+!
+! Revision 1.7  2001/03/29 17:35:08  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.6  2001/01/22 04:57:23  raasch
+! Module test_variables removed
+!
+! Revision 1.5  2000/01/20 09:40:00  letzel
+! All comments translated into English
+!
+! Revision 1.4  1998/07/06 12:04:43  raasch
+! + USE test_variables
+!
+! Revision 1.3  1998/04/21 15:52:51  raasch
+! Galilei-Transformation eingebaut
+!
+! Revision 1.2  1997/09/09 08:27:49  raasch
+! Kehrwerte der Gitterweiten implementiert
 !
 ! Revision 1.1  1997/08/29 08:55:25  raasch
@@ -38,10 +51,8 @@
 ! Description:
 ! ------------
-!> Advection term for the u velocity-component using upstream scheme.
-!> NOTE: vertical advection at k=1 still has wrong grid spacing for w>0!
-!>       The same problem occurs for all topography boundaries!
-!--------------------------------------------------------------------------------------------------!
- MODULE advec_u_up_mod
-
+! Advection term for the u velocity-component using upstream scheme.
+! NOTE: vertical advection at k=1 still has wrong grid spacing for w>0!
+!       The same problem occurs for all topography boundaries!
+!------------------------------------------------------------------------------!
 
     PRIVATE
@@ -56,134 +67,117 @@
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for all grid points
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_u_up
+!------------------------------------------------------------------------------!
+! Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_u_up
 
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzu, tend, u, v, w
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
+       IMPLICIT NONE
 
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
+       INTEGER ::  i, j, k
 
-    USE indices,                                                                                   &
-        ONLY:  nxlu, nxr, nyn, nys, nzb, nzt
-
-    USE kinds
+       REAL ::  ukomp, vkomp, wkomp
 
 
-    IMPLICIT NONE
+       DO  i = nxl, nxr+uxrp
+          DO  j = nys, nyn
+             DO  k = nzb_u_inner(j,i)+1, nzt
+!
+!--             x-direction
+                ukomp = u(k,j,i) - u_gtrans
+                IF ( ukomp > 0.0 )  THEN
+                   tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( u(k,j,i) - u(k,j,i-1) ) * ddx
+                ELSE
+                   tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                          ( u(k,j,i+1) - u(k,j,i) ) * ddx
+                ENDIF
+!
+!--             y-direction
+                vkomp = 0.25 * ( v(k,j,i)   + v(k,j+1,i) + &
+                                 v(k,j,i-1) + v(k,j+1,i-1) ) - v_gtrans
+                IF ( vkomp > 0.0 )  THEN
+                   tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( u(k,j,i) - u(k,j-1,i) ) * ddy
+                ELSE
+                   tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( u(k,j+1,i) - u(k,j,i) ) * ddy
+                ENDIF
+!
+!--             z-direction
+                wkomp = 0.25 * ( w(k,j,i)   + w(k-1,j,i) + &
+                                 w(k,j,i-1) + w(k-1,j,i-1) )
+                IF ( wkomp > 0.0 )  THEN
+                   tend(k,j,i) = tend(k,j,i) - wkomp * &
+                                         ( u(k,j,i) - u(k-1,j,i) ) * ddzu(k)
+                ELSE
+                   tend(k,j,i) = tend(k,j,i) - wkomp * &
+                                         ( u(k+1,j,i) - u(k,j,i) ) * ddzu(k+1)
+                ENDIF
 
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
+             ENDDO
+          ENDDO
+       ENDDO
 
-    REAL(wp) ::  ukomp !< advection velocity along x-direction
-    REAL(wp) ::  vkomp !< advection velocity along y-direction
-    REAL(wp) ::  wkomp !< advection velocity along z-direction
+    END SUBROUTINE advec_u_up
 
 
-    DO  i = nxlu, nxr
-       DO  j = nys, nyn
-          DO  k = nzb+1, nzt
-!
-!--          x-direction
-             ukomp = u(k,j,i) - u_gtrans
-             IF ( ukomp > 0.0_wp )  THEN
-                tend(k,j,i) = tend(k,j,i) - ukomp * ( u(k,j,i) - u(k,j,i-1) ) * ddx
-             ELSE
-                tend(k,j,i) = tend(k,j,i) - ukomp * ( u(k,j,i+1) - u(k,j,i) ) * ddx
-             ENDIF
-!
-!--          y-direction
-             vkomp = 0.25_wp * ( v(k,j,i) + v(k,j+1,i) + v(k,j,i-1) + v(k,j+1,i-1) ) - v_gtrans
-             IF ( vkomp > 0.0_wp )  THEN
-                tend(k,j,i) = tend(k,j,i) - vkomp * ( u(k,j,i) - u(k,j-1,i) ) * ddy
-             ELSE
-                tend(k,j,i) = tend(k,j,i) - vkomp * ( u(k,j+1,i) - u(k,j,i) ) * ddy
-             ENDIF
-!
-!--          z-direction
-             wkomp = 0.25_wp * ( w(k,j,i) + w(k-1,j,i) + w(k,j,i-1) + w(k-1,j,i-1) )
-             IF ( wkomp > 0.0_wp )  THEN
-                tend(k,j,i) = tend(k,j,i) - wkomp * ( u(k,j,i) - u(k-1,j,i) ) * ddzu(k)
-             ELSE
-                tend(k,j,i) = tend(k,j,i) - wkomp * ( u(k+1,j,i) - u(k,j,i) ) * ddzu(k+1)
-             ENDIF
+!------------------------------------------------------------------------------!
+! Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_u_up_ij( i, j )
 
-          ENDDO
-       ENDDO
-    ENDDO
+       USE arrays_3d
+       USE control_parameters
+       USE grid_variables
+       USE indices
 
- END SUBROUTINE advec_u_up
+       IMPLICIT NONE
+
+       INTEGER ::  i, j, k
+
+       REAL ::  ukomp, vkomp, wkomp
 
 
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Call for grid point i,j
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE advec_u_up_ij( i, j )
+       DO  k = nzb_u_inner(j,i)+1, nzt
+!
+!--       x-direction
+          ukomp = u(k,j,i) - u_gtrans
+          IF ( ukomp > 0.0 )  THEN
+             tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( u(k,j,i) - u(k,j,i-1) ) * ddx
+          ELSE
+             tend(k,j,i) = tend(k,j,i) - ukomp * &
+                                         ( u(k,j,i+1) - u(k,j,i) ) * ddx
+          ENDIF
+!
+!--       y-direction
+          vkomp = 0.25 * ( v(k,j,i) + v(k,j+1,i) + v(k,j,i-1) + v(k,j+1,i-1) &
+                         ) - v_gtrans
+          IF ( vkomp > 0.0 )  THEN
+             tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( u(k,j,i) - u(k,j-1,i) ) * ddy
+          ELSE
+             tend(k,j,i) = tend(k,j,i) - vkomp * &
+                                         ( u(k,j+1,i) - u(k,j,i) ) * ddy
+          ENDIF
+!
+!--       z-direction
+          wkomp = 0.25 * ( w(k,j,i) + w(k-1,j,i) + w(k,j,i-1) + w(k-1,j,i-1) )
+          IF ( wkomp > 0.0 )  THEN
+             tend(k,j,i) = tend(k,j,i) - wkomp * &
+                                         ( u(k,j,i) - u(k-1,j,i) ) * ddzu(k)
+          ELSE
+             tend(k,j,i) = tend(k,j,i) - wkomp * &
+                                         ( u(k+1,j,i) - u(k,j,i) ) * ddzu(k+1)
+          ENDIF
 
-    USE arrays_3d,                                                                                 &
-        ONLY:  ddzu, tend, u, v, w
+       ENDDO
 
-    USE control_parameters,                                                                        &
-        ONLY:  u_gtrans, v_gtrans
-
-    USE grid_variables,                                                                            &
-        ONLY:  ddx, ddy
-
-    USE indices,                                                                                   &
-        ONLY:  nzb, nzt
-
-    USE kinds
-
-
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i !< grid index along x-direction
-    INTEGER(iwp) ::  j !< grid index along y-direction
-    INTEGER(iwp) ::  k !< grid index along z-direction
-
-    REAL(wp) ::  ukomp !< advection velocity along x-direction
-    REAL(wp) ::  vkomp !< advection velocity along y-direction
-    REAL(wp) ::  wkomp !< advection velocity along z-direction
-
-
-    DO  k = nzb+1, nzt
-!
-!--    x-direction
-       ukomp = u(k,j,i) - u_gtrans
-       IF ( ukomp > 0.0_wp )  THEN
-          tend(k,j,i) = tend(k,j,i) - ukomp * ( u(k,j,i) - u(k,j,i-1) ) * ddx
-       ELSE
-          tend(k,j,i) = tend(k,j,i) - ukomp * ( u(k,j,i+1) - u(k,j,i) ) * ddx
-       ENDIF
-!
-!--    y-direction
-       vkomp = 0.25_wp * ( v(k,j,i) + v(k,j+1,i) + v(k,j,i-1) + v(k,j+1,i-1) ) - v_gtrans
-       IF ( vkomp > 0.0_wp )  THEN
-          tend(k,j,i) = tend(k,j,i) - vkomp * ( u(k,j,i) - u(k,j-1,i) ) * ddy
-       ELSE
-          tend(k,j,i) = tend(k,j,i) - vkomp * ( u(k,j+1,i) - u(k,j,i) ) * ddy
-       ENDIF
-!
-!--    z-direction
-       wkomp = 0.25_wp * ( w(k,j,i) + w(k-1,j,i) + w(k,j,i-1) + w(k-1,j,i-1) )
-       IF ( wkomp > 0.0_wp )  THEN
-          tend(k,j,i) = tend(k,j,i) - wkomp * ( u(k,j,i) - u(k-1,j,i) ) * ddzu(k)
-       ELSE
-          tend(k,j,i) = tend(k,j,i) - wkomp * ( u(k+1,j,i) - u(k,j,i) ) * ddzu(k+1)
-       ENDIF
-
-    ENDDO
-
- END SUBROUTINE advec_u_up_ij
+    END SUBROUTINE advec_u_up_ij
 
  END MODULE advec_u_up_mod
